// Code generated by go-swagger; DO NOT EDIT.

package billing_account_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewBillingAccountServiceDeleteBillingAccountParams creates a new BillingAccountServiceDeleteBillingAccountParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewBillingAccountServiceDeleteBillingAccountParams() *BillingAccountServiceDeleteBillingAccountParams {
	return &BillingAccountServiceDeleteBillingAccountParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewBillingAccountServiceDeleteBillingAccountParamsWithTimeout creates a new BillingAccountServiceDeleteBillingAccountParams object
// with the ability to set a timeout on a request.
func NewBillingAccountServiceDeleteBillingAccountParamsWithTimeout(timeout time.Duration) *BillingAccountServiceDeleteBillingAccountParams {
	return &BillingAccountServiceDeleteBillingAccountParams{
		timeout: timeout,
	}
}

// NewBillingAccountServiceDeleteBillingAccountParamsWithContext creates a new BillingAccountServiceDeleteBillingAccountParams object
// with the ability to set a context for a request.
func NewBillingAccountServiceDeleteBillingAccountParamsWithContext(ctx context.Context) *BillingAccountServiceDeleteBillingAccountParams {
	return &BillingAccountServiceDeleteBillingAccountParams{
		Context: ctx,
	}
}

// NewBillingAccountServiceDeleteBillingAccountParamsWithHTTPClient creates a new BillingAccountServiceDeleteBillingAccountParams object
// with the ability to set a custom HTTPClient for a request.
func NewBillingAccountServiceDeleteBillingAccountParamsWithHTTPClient(client *http.Client) *BillingAccountServiceDeleteBillingAccountParams {
	return &BillingAccountServiceDeleteBillingAccountParams{
		HTTPClient: client,
	}
}

/*
BillingAccountServiceDeleteBillingAccountParams contains all the parameters to send to the API endpoint

	for the billing account service delete billing account operation.

	Typically these are written to a http.Request.
*/
type BillingAccountServiceDeleteBillingAccountParams struct {

	/* ID.

	   id references the billing account to be deleted.
	*/
	ID string

	/* OrganizationID.

	     organization_id references the organization that owns the billing account
	to be deleted.
	*/
	OrganizationID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the billing account service delete billing account params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *BillingAccountServiceDeleteBillingAccountParams) WithDefaults() *BillingAccountServiceDeleteBillingAccountParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the billing account service delete billing account params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *BillingAccountServiceDeleteBillingAccountParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) WithTimeout(timeout time.Duration) *BillingAccountServiceDeleteBillingAccountParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) WithContext(ctx context.Context) *BillingAccountServiceDeleteBillingAccountParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) WithHTTPClient(client *http.Client) *BillingAccountServiceDeleteBillingAccountParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) WithID(id string) *BillingAccountServiceDeleteBillingAccountParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) SetID(id string) {
	o.ID = id
}

// WithOrganizationID adds the organizationID to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) WithOrganizationID(organizationID string) *BillingAccountServiceDeleteBillingAccountParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the billing account service delete billing account params
func (o *BillingAccountServiceDeleteBillingAccountParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WriteToRequest writes these params to a swagger request
func (o *BillingAccountServiceDeleteBillingAccountParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
