// Code generated by go-swagger; DO NOT EDIT.

package billing_account_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-billing/preview/2020-11-05/models"
)

// BillingAccountServiceDeleteBillingAccountReader is a Reader for the BillingAccountServiceDeleteBillingAccount structure.
type BillingAccountServiceDeleteBillingAccountReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *BillingAccountServiceDeleteBillingAccountReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewBillingAccountServiceDeleteBillingAccountOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewBillingAccountServiceDeleteBillingAccountDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewBillingAccountServiceDeleteBillingAccountOK creates a BillingAccountServiceDeleteBillingAccountOK with default headers values
func NewBillingAccountServiceDeleteBillingAccountOK() *BillingAccountServiceDeleteBillingAccountOK {
	return &BillingAccountServiceDeleteBillingAccountOK{}
}

/*
BillingAccountServiceDeleteBillingAccountOK describes a response with status code 200, with default header values.

A successful response.
*/
type BillingAccountServiceDeleteBillingAccountOK struct {
	Payload models.Billing20201105DeleteBillingAccountResponse
}

// IsSuccess returns true when this billing account service delete billing account o k response has a 2xx status code
func (o *BillingAccountServiceDeleteBillingAccountOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this billing account service delete billing account o k response has a 3xx status code
func (o *BillingAccountServiceDeleteBillingAccountOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this billing account service delete billing account o k response has a 4xx status code
func (o *BillingAccountServiceDeleteBillingAccountOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this billing account service delete billing account o k response has a 5xx status code
func (o *BillingAccountServiceDeleteBillingAccountOK) IsServerError() bool {
	return false
}

// IsCode returns true when this billing account service delete billing account o k response a status code equal to that given
func (o *BillingAccountServiceDeleteBillingAccountOK) IsCode(code int) bool {
	return code == 200
}

func (o *BillingAccountServiceDeleteBillingAccountOK) Error() string {
	return fmt.Sprintf("[DELETE /billing/2020-11-05/organizations/{organization_id}/accounts/{id}][%d] billingAccountServiceDeleteBillingAccountOK  %+v", 200, o.Payload)
}

func (o *BillingAccountServiceDeleteBillingAccountOK) String() string {
	return fmt.Sprintf("[DELETE /billing/2020-11-05/organizations/{organization_id}/accounts/{id}][%d] billingAccountServiceDeleteBillingAccountOK  %+v", 200, o.Payload)
}

func (o *BillingAccountServiceDeleteBillingAccountOK) GetPayload() models.Billing20201105DeleteBillingAccountResponse {
	return o.Payload
}

func (o *BillingAccountServiceDeleteBillingAccountOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBillingAccountServiceDeleteBillingAccountDefault creates a BillingAccountServiceDeleteBillingAccountDefault with default headers values
func NewBillingAccountServiceDeleteBillingAccountDefault(code int) *BillingAccountServiceDeleteBillingAccountDefault {
	return &BillingAccountServiceDeleteBillingAccountDefault{
		_statusCode: code,
	}
}

/*
BillingAccountServiceDeleteBillingAccountDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type BillingAccountServiceDeleteBillingAccountDefault struct {
	_statusCode int

	Payload *models.RuntimeError
}

// Code gets the status code for the billing account service delete billing account default response
func (o *BillingAccountServiceDeleteBillingAccountDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this billing account service delete billing account default response has a 2xx status code
func (o *BillingAccountServiceDeleteBillingAccountDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this billing account service delete billing account default response has a 3xx status code
func (o *BillingAccountServiceDeleteBillingAccountDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this billing account service delete billing account default response has a 4xx status code
func (o *BillingAccountServiceDeleteBillingAccountDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this billing account service delete billing account default response has a 5xx status code
func (o *BillingAccountServiceDeleteBillingAccountDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this billing account service delete billing account default response a status code equal to that given
func (o *BillingAccountServiceDeleteBillingAccountDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *BillingAccountServiceDeleteBillingAccountDefault) Error() string {
	return fmt.Sprintf("[DELETE /billing/2020-11-05/organizations/{organization_id}/accounts/{id}][%d] BillingAccountService_DeleteBillingAccount default  %+v", o._statusCode, o.Payload)
}

func (o *BillingAccountServiceDeleteBillingAccountDefault) String() string {
	return fmt.Sprintf("[DELETE /billing/2020-11-05/organizations/{organization_id}/accounts/{id}][%d] BillingAccountService_DeleteBillingAccount default  %+v", o._statusCode, o.Payload)
}

func (o *BillingAccountServiceDeleteBillingAccountDefault) GetPayload() *models.RuntimeError {
	return o.Payload
}

func (o *BillingAccountServiceDeleteBillingAccountDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RuntimeError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
