// Code generated by go-swagger; DO NOT EDIT.

package architecture_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewCompleteDirectUploadBoxParams creates a new CompleteDirectUploadBoxParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCompleteDirectUploadBoxParams() *CompleteDirectUploadBoxParams {
	return &CompleteDirectUploadBoxParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCompleteDirectUploadBoxParamsWithTimeout creates a new CompleteDirectUploadBoxParams object
// with the ability to set a timeout on a request.
func NewCompleteDirectUploadBoxParamsWithTimeout(timeout time.Duration) *CompleteDirectUploadBoxParams {
	return &CompleteDirectUploadBoxParams{
		timeout: timeout,
	}
}

// NewCompleteDirectUploadBoxParamsWithContext creates a new CompleteDirectUploadBoxParams object
// with the ability to set a context for a request.
func NewCompleteDirectUploadBoxParamsWithContext(ctx context.Context) *CompleteDirectUploadBoxParams {
	return &CompleteDirectUploadBoxParams{
		Context: ctx,
	}
}

// NewCompleteDirectUploadBoxParamsWithHTTPClient creates a new CompleteDirectUploadBoxParams object
// with the ability to set a custom HTTPClient for a request.
func NewCompleteDirectUploadBoxParamsWithHTTPClient(client *http.Client) *CompleteDirectUploadBoxParams {
	return &CompleteDirectUploadBoxParams{
		HTTPClient: client,
	}
}

/*
CompleteDirectUploadBoxParams contains all the parameters to send to the API endpoint

	for the complete direct upload box operation.

	Typically these are written to a http.Request.
*/
type CompleteDirectUploadBoxParams struct {

	/* Architecture.

	   The name of the Architecture.
	*/
	Architecture string

	/* Box.

	     The name segment of the Box. As an example, this field would represent the
	"vagrant" in "hashicorp/vagrant".
	*/
	Box string

	/* Bytes.

	   Size of the artifact uploaded.

	   Format: uint64
	*/
	Bytes *string

	/* Key.

	   Storage key of the upload.
	*/
	Key *string

	/* Object.

	   Object identifier.
	*/
	Object string

	/* Provider.

	   The name of the Provider.
	*/
	Provider string

	/* Registry.

	     The Registry segment of the Box. As an example, this field would represent
	the "hashicorp" in "hashicorp/vagrant".
	*/
	Registry string

	/* Success.

	   Success status of the upload.
	*/
	Success *bool

	/* Version.

	   The name of the Version for the Provider.
	*/
	Version string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the complete direct upload box params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CompleteDirectUploadBoxParams) WithDefaults() *CompleteDirectUploadBoxParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the complete direct upload box params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CompleteDirectUploadBoxParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithTimeout(timeout time.Duration) *CompleteDirectUploadBoxParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithContext(ctx context.Context) *CompleteDirectUploadBoxParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithHTTPClient(client *http.Client) *CompleteDirectUploadBoxParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithArchitecture adds the architecture to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithArchitecture(architecture string) *CompleteDirectUploadBoxParams {
	o.SetArchitecture(architecture)
	return o
}

// SetArchitecture adds the architecture to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetArchitecture(architecture string) {
	o.Architecture = architecture
}

// WithBox adds the box to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithBox(box string) *CompleteDirectUploadBoxParams {
	o.SetBox(box)
	return o
}

// SetBox adds the box to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetBox(box string) {
	o.Box = box
}

// WithBytes adds the bytes to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithBytes(bytes *string) *CompleteDirectUploadBoxParams {
	o.SetBytes(bytes)
	return o
}

// SetBytes adds the bytes to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetBytes(bytes *string) {
	o.Bytes = bytes
}

// WithKey adds the key to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithKey(key *string) *CompleteDirectUploadBoxParams {
	o.SetKey(key)
	return o
}

// SetKey adds the key to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetKey(key *string) {
	o.Key = key
}

// WithObject adds the object to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithObject(object string) *CompleteDirectUploadBoxParams {
	o.SetObject(object)
	return o
}

// SetObject adds the object to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetObject(object string) {
	o.Object = object
}

// WithProvider adds the provider to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithProvider(provider string) *CompleteDirectUploadBoxParams {
	o.SetProvider(provider)
	return o
}

// SetProvider adds the provider to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetProvider(provider string) {
	o.Provider = provider
}

// WithRegistry adds the registry to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithRegistry(registry string) *CompleteDirectUploadBoxParams {
	o.SetRegistry(registry)
	return o
}

// SetRegistry adds the registry to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetRegistry(registry string) {
	o.Registry = registry
}

// WithSuccess adds the success to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithSuccess(success *bool) *CompleteDirectUploadBoxParams {
	o.SetSuccess(success)
	return o
}

// SetSuccess adds the success to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetSuccess(success *bool) {
	o.Success = success
}

// WithVersion adds the version to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) WithVersion(version string) *CompleteDirectUploadBoxParams {
	o.SetVersion(version)
	return o
}

// SetVersion adds the version to the complete direct upload box params
func (o *CompleteDirectUploadBoxParams) SetVersion(version string) {
	o.Version = version
}

// WriteToRequest writes these params to a swagger request
func (o *CompleteDirectUploadBoxParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param architecture
	if err := r.SetPathParam("architecture", o.Architecture); err != nil {
		return err
	}

	// path param box
	if err := r.SetPathParam("box", o.Box); err != nil {
		return err
	}

	if o.Bytes != nil {

		// query param bytes
		var qrBytes string

		if o.Bytes != nil {
			qrBytes = *o.Bytes
		}
		qBytes := qrBytes
		if qBytes != "" {

			if err := r.SetQueryParam("bytes", qBytes); err != nil {
				return err
			}
		}
	}

	if o.Key != nil {

		// query param key
		var qrKey string

		if o.Key != nil {
			qrKey = *o.Key
		}
		qKey := qrKey
		if qKey != "" {

			if err := r.SetQueryParam("key", qKey); err != nil {
				return err
			}
		}
	}

	// path param object
	if err := r.SetPathParam("object", o.Object); err != nil {
		return err
	}

	// path param provider
	if err := r.SetPathParam("provider", o.Provider); err != nil {
		return err
	}

	// path param registry
	if err := r.SetPathParam("registry", o.Registry); err != nil {
		return err
	}

	if o.Success != nil {

		// query param success
		var qrSuccess bool

		if o.Success != nil {
			qrSuccess = *o.Success
		}
		qSuccess := swag.FormatBool(qrSuccess)
		if qSuccess != "" {

			if err := r.SetQueryParam("success", qSuccess); err != nil {
				return err
			}
		}
	}

	// path param version
	if err := r.SetPathParam("version", o.Version); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
