// Code generated by go-swagger; DO NOT EDIT.

package architecture_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCompleteUploadBoxParams creates a new CompleteUploadBoxParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCompleteUploadBoxParams() *CompleteUploadBoxParams {
	return &CompleteUploadBoxParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCompleteUploadBoxParamsWithTimeout creates a new CompleteUploadBoxParams object
// with the ability to set a timeout on a request.
func NewCompleteUploadBoxParamsWithTimeout(timeout time.Duration) *CompleteUploadBoxParams {
	return &CompleteUploadBoxParams{
		timeout: timeout,
	}
}

// NewCompleteUploadBoxParamsWithContext creates a new CompleteUploadBoxParams object
// with the ability to set a context for a request.
func NewCompleteUploadBoxParamsWithContext(ctx context.Context) *CompleteUploadBoxParams {
	return &CompleteUploadBoxParams{
		Context: ctx,
	}
}

// NewCompleteUploadBoxParamsWithHTTPClient creates a new CompleteUploadBoxParams object
// with the ability to set a custom HTTPClient for a request.
func NewCompleteUploadBoxParamsWithHTTPClient(client *http.Client) *CompleteUploadBoxParams {
	return &CompleteUploadBoxParams{
		HTTPClient: client,
	}
}

/*
CompleteUploadBoxParams contains all the parameters to send to the API endpoint

	for the complete upload box operation.

	Typically these are written to a http.Request.
*/
type CompleteUploadBoxParams struct {

	/* Architecture.

	   The name of the Architecture.
	*/
	Architecture string

	// Body.
	Body CompleteUploadBoxBody

	/* Box.

	     The name segment of the Box. As an example, this field would represent the
	"vagrant" in "hashicorp/vagrant".
	*/
	Box string

	/* Provider.

	   The name of the Provider.
	*/
	Provider string

	/* Registry.

	     The Registry segment of the Box. As an example, this field would represent
	the "hashicorp" in "hashicorp/vagrant".
	*/
	Registry string

	/* Version.

	   The name of the Version for the Provider.
	*/
	Version string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the complete upload box params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CompleteUploadBoxParams) WithDefaults() *CompleteUploadBoxParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the complete upload box params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CompleteUploadBoxParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the complete upload box params
func (o *CompleteUploadBoxParams) WithTimeout(timeout time.Duration) *CompleteUploadBoxParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the complete upload box params
func (o *CompleteUploadBoxParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the complete upload box params
func (o *CompleteUploadBoxParams) WithContext(ctx context.Context) *CompleteUploadBoxParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the complete upload box params
func (o *CompleteUploadBoxParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the complete upload box params
func (o *CompleteUploadBoxParams) WithHTTPClient(client *http.Client) *CompleteUploadBoxParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the complete upload box params
func (o *CompleteUploadBoxParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithArchitecture adds the architecture to the complete upload box params
func (o *CompleteUploadBoxParams) WithArchitecture(architecture string) *CompleteUploadBoxParams {
	o.SetArchitecture(architecture)
	return o
}

// SetArchitecture adds the architecture to the complete upload box params
func (o *CompleteUploadBoxParams) SetArchitecture(architecture string) {
	o.Architecture = architecture
}

// WithBody adds the body to the complete upload box params
func (o *CompleteUploadBoxParams) WithBody(body CompleteUploadBoxBody) *CompleteUploadBoxParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the complete upload box params
func (o *CompleteUploadBoxParams) SetBody(body CompleteUploadBoxBody) {
	o.Body = body
}

// WithBox adds the box to the complete upload box params
func (o *CompleteUploadBoxParams) WithBox(box string) *CompleteUploadBoxParams {
	o.SetBox(box)
	return o
}

// SetBox adds the box to the complete upload box params
func (o *CompleteUploadBoxParams) SetBox(box string) {
	o.Box = box
}

// WithProvider adds the provider to the complete upload box params
func (o *CompleteUploadBoxParams) WithProvider(provider string) *CompleteUploadBoxParams {
	o.SetProvider(provider)
	return o
}

// SetProvider adds the provider to the complete upload box params
func (o *CompleteUploadBoxParams) SetProvider(provider string) {
	o.Provider = provider
}

// WithRegistry adds the registry to the complete upload box params
func (o *CompleteUploadBoxParams) WithRegistry(registry string) *CompleteUploadBoxParams {
	o.SetRegistry(registry)
	return o
}

// SetRegistry adds the registry to the complete upload box params
func (o *CompleteUploadBoxParams) SetRegistry(registry string) {
	o.Registry = registry
}

// WithVersion adds the version to the complete upload box params
func (o *CompleteUploadBoxParams) WithVersion(version string) *CompleteUploadBoxParams {
	o.SetVersion(version)
	return o
}

// SetVersion adds the version to the complete upload box params
func (o *CompleteUploadBoxParams) SetVersion(version string) {
	o.Version = version
}

// WriteToRequest writes these params to a swagger request
func (o *CompleteUploadBoxParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param architecture
	if err := r.SetPathParam("architecture", o.Architecture); err != nil {
		return err
	}
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param box
	if err := r.SetPathParam("box", o.Box); err != nil {
		return err
	}

	// path param provider
	if err := r.SetPathParam("provider", o.Provider); err != nil {
		return err
	}

	// path param registry
	if err := r.SetPathParam("registry", o.Registry); err != nil {
		return err
	}

	// path param version
	if err := r.SetPathParam("version", o.Version); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
