// Code generated by go-swagger; DO NOT EDIT.

package architecture_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	cloud "github.com/hashicorp/hcp-sdk-go/clients/cloud-shared/v1/models"
	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vagrant-box-registry/preview/2022-09-30/models"
)

// CreateArchitectureReader is a Reader for the CreateArchitecture structure.
type CreateArchitectureReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateArchitectureReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewCreateArchitectureOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewCreateArchitectureDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewCreateArchitectureOK creates a CreateArchitectureOK with default headers values
func NewCreateArchitectureOK() *CreateArchitectureOK {
	return &CreateArchitectureOK{}
}

/*
CreateArchitectureOK describes a response with status code 200, with default header values.

A successful response.
*/
type CreateArchitectureOK struct {
	Payload *models.HashicorpCloudVagrant20220930CreateArchitectureResponse
}

// IsSuccess returns true when this create architecture o k response has a 2xx status code
func (o *CreateArchitectureOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this create architecture o k response has a 3xx status code
func (o *CreateArchitectureOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create architecture o k response has a 4xx status code
func (o *CreateArchitectureOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this create architecture o k response has a 5xx status code
func (o *CreateArchitectureOK) IsServerError() bool {
	return false
}

// IsCode returns true when this create architecture o k response a status code equal to that given
func (o *CreateArchitectureOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the create architecture o k response
func (o *CreateArchitectureOK) Code() int {
	return 200
}

func (o *CreateArchitectureOK) Error() string {
	return fmt.Sprintf("[PUT /vagrant/2022-09-30/registry/{registry}/boxes/{box}/versions/{version}/providers/{provider}/architectures][%d] createArchitectureOK  %+v", 200, o.Payload)
}

func (o *CreateArchitectureOK) String() string {
	return fmt.Sprintf("[PUT /vagrant/2022-09-30/registry/{registry}/boxes/{box}/versions/{version}/providers/{provider}/architectures][%d] createArchitectureOK  %+v", 200, o.Payload)
}

func (o *CreateArchitectureOK) GetPayload() *models.HashicorpCloudVagrant20220930CreateArchitectureResponse {
	return o.Payload
}

func (o *CreateArchitectureOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.HashicorpCloudVagrant20220930CreateArchitectureResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateArchitectureDefault creates a CreateArchitectureDefault with default headers values
func NewCreateArchitectureDefault(code int) *CreateArchitectureDefault {
	return &CreateArchitectureDefault{
		_statusCode: code,
	}
}

/*
CreateArchitectureDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type CreateArchitectureDefault struct {
	_statusCode int

	Payload *cloud.GoogleRPCStatus
}

// IsSuccess returns true when this create architecture default response has a 2xx status code
func (o *CreateArchitectureDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this create architecture default response has a 3xx status code
func (o *CreateArchitectureDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this create architecture default response has a 4xx status code
func (o *CreateArchitectureDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this create architecture default response has a 5xx status code
func (o *CreateArchitectureDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this create architecture default response a status code equal to that given
func (o *CreateArchitectureDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the create architecture default response
func (o *CreateArchitectureDefault) Code() int {
	return o._statusCode
}

func (o *CreateArchitectureDefault) Error() string {
	return fmt.Sprintf("[PUT /vagrant/2022-09-30/registry/{registry}/boxes/{box}/versions/{version}/providers/{provider}/architectures][%d] CreateArchitecture default  %+v", o._statusCode, o.Payload)
}

func (o *CreateArchitectureDefault) String() string {
	return fmt.Sprintf("[PUT /vagrant/2022-09-30/registry/{registry}/boxes/{box}/versions/{version}/providers/{provider}/architectures][%d] CreateArchitecture default  %+v", o._statusCode, o.Payload)
}

func (o *CreateArchitectureDefault) GetPayload() *cloud.GoogleRPCStatus {
	return o.Payload
}

func (o *CreateArchitectureDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud.GoogleRPCStatus)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*
CreateArchitectureBody create architecture body
swagger:model CreateArchitectureBody
*/
type CreateArchitectureBody struct {

	// Details of the Architecture to create.
	Data *models.HashicorpCloudVagrant20220930Architecture `json:"data,omitempty"`
}

// Validate validates this create architecture body
func (o *CreateArchitectureBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *CreateArchitectureBody) validateData(formats strfmt.Registry) error {
	if swag.IsZero(o.Data) { // not required
		return nil
	}

	if o.Data != nil {
		if err := o.Data.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("body" + "." + "data")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("body" + "." + "data")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this create architecture body based on the context it is used
func (o *CreateArchitectureBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateData(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *CreateArchitectureBody) contextValidateData(ctx context.Context, formats strfmt.Registry) error {

	if o.Data != nil {

		if swag.IsZero(o.Data) { // not required
			return nil
		}

		if err := o.Data.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("body" + "." + "data")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("body" + "." + "data")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (o *CreateArchitectureBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *CreateArchitectureBody) UnmarshalBinary(b []byte) error {
	var res CreateArchitectureBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
