// Code generated by go-swagger; DO NOT EDIT.

package provider_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	cloud "github.com/hashicorp/hcp-sdk-go/clients/cloud-shared/v1/models"
	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vagrant-box-registry/preview/2022-09-30/models"
)

// GetProviderReader is a Reader for the GetProvider structure.
type GetProviderReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetProviderReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetProviderOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewGetProviderDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetProviderOK creates a GetProviderOK with default headers values
func NewGetProviderOK() *GetProviderOK {
	return &GetProviderOK{}
}

/*
GetProviderOK describes a response with status code 200, with default header values.

A successful response.
*/
type GetProviderOK struct {
	Payload *models.HashicorpCloudVagrant20220930GetProviderResponse
}

// IsSuccess returns true when this get provider o k response has a 2xx status code
func (o *GetProviderOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get provider o k response has a 3xx status code
func (o *GetProviderOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get provider o k response has a 4xx status code
func (o *GetProviderOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get provider o k response has a 5xx status code
func (o *GetProviderOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get provider o k response a status code equal to that given
func (o *GetProviderOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get provider o k response
func (o *GetProviderOK) Code() int {
	return 200
}

func (o *GetProviderOK) Error() string {
	return fmt.Sprintf("[GET /vagrant/2022-09-30/registry/{registry}/boxes/{box}/versions/{version}/g_providers/{provider}][%d] getProviderOK  %+v", 200, o.Payload)
}

func (o *GetProviderOK) String() string {
	return fmt.Sprintf("[GET /vagrant/2022-09-30/registry/{registry}/boxes/{box}/versions/{version}/g_providers/{provider}][%d] getProviderOK  %+v", 200, o.Payload)
}

func (o *GetProviderOK) GetPayload() *models.HashicorpCloudVagrant20220930GetProviderResponse {
	return o.Payload
}

func (o *GetProviderOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.HashicorpCloudVagrant20220930GetProviderResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetProviderDefault creates a GetProviderDefault with default headers values
func NewGetProviderDefault(code int) *GetProviderDefault {
	return &GetProviderDefault{
		_statusCode: code,
	}
}

/*
GetProviderDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type GetProviderDefault struct {
	_statusCode int

	Payload *cloud.GoogleRPCStatus
}

// IsSuccess returns true when this get provider default response has a 2xx status code
func (o *GetProviderDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get provider default response has a 3xx status code
func (o *GetProviderDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get provider default response has a 4xx status code
func (o *GetProviderDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get provider default response has a 5xx status code
func (o *GetProviderDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get provider default response a status code equal to that given
func (o *GetProviderDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get provider default response
func (o *GetProviderDefault) Code() int {
	return o._statusCode
}

func (o *GetProviderDefault) Error() string {
	return fmt.Sprintf("[GET /vagrant/2022-09-30/registry/{registry}/boxes/{box}/versions/{version}/g_providers/{provider}][%d] GetProvider default  %+v", o._statusCode, o.Payload)
}

func (o *GetProviderDefault) String() string {
	return fmt.Sprintf("[GET /vagrant/2022-09-30/registry/{registry}/boxes/{box}/versions/{version}/g_providers/{provider}][%d] GetProvider default  %+v", o._statusCode, o.Payload)
}

func (o *GetProviderDefault) GetPayload() *cloud.GoogleRPCStatus {
	return o.Payload
}

func (o *GetProviderDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud.GoogleRPCStatus)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
