// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vault-secrets/preview/2023-11-28/models"
)

// UpdateAppReader is a Reader for the UpdateApp structure.
type UpdateAppReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateAppReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateAppOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewUpdateAppDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateAppOK creates a UpdateAppOK with default headers values
func NewUpdateAppOK() *UpdateAppOK {
	return &UpdateAppOK{}
}

/*
UpdateAppOK describes a response with status code 200, with default header values.

A successful response.
*/
type UpdateAppOK struct {
	Payload *models.Secrets20231128UpdateAppResponse
}

// IsSuccess returns true when this update app o k response has a 2xx status code
func (o *UpdateAppOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update app o k response has a 3xx status code
func (o *UpdateAppOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update app o k response has a 4xx status code
func (o *UpdateAppOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update app o k response has a 5xx status code
func (o *UpdateAppOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update app o k response a status code equal to that given
func (o *UpdateAppOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update app o k response
func (o *UpdateAppOK) Code() int {
	return 200
}

func (o *UpdateAppOK) Error() string {
	return fmt.Sprintf("[PATCH /secrets/2023-11-28/organizations/{organization_id}/projects/{project_id}/apps/{name}][%d] updateAppOK  %+v", 200, o.Payload)
}

func (o *UpdateAppOK) String() string {
	return fmt.Sprintf("[PATCH /secrets/2023-11-28/organizations/{organization_id}/projects/{project_id}/apps/{name}][%d] updateAppOK  %+v", 200, o.Payload)
}

func (o *UpdateAppOK) GetPayload() *models.Secrets20231128UpdateAppResponse {
	return o.Payload
}

func (o *UpdateAppOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Secrets20231128UpdateAppResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateAppDefault creates a UpdateAppDefault with default headers values
func NewUpdateAppDefault(code int) *UpdateAppDefault {
	return &UpdateAppDefault{
		_statusCode: code,
	}
}

/*
UpdateAppDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type UpdateAppDefault struct {
	_statusCode int

	Payload *models.RPCStatus
}

// IsSuccess returns true when this update app default response has a 2xx status code
func (o *UpdateAppDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update app default response has a 3xx status code
func (o *UpdateAppDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update app default response has a 4xx status code
func (o *UpdateAppDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update app default response has a 5xx status code
func (o *UpdateAppDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update app default response a status code equal to that given
func (o *UpdateAppDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update app default response
func (o *UpdateAppDefault) Code() int {
	return o._statusCode
}

func (o *UpdateAppDefault) Error() string {
	return fmt.Sprintf("[PATCH /secrets/2023-11-28/organizations/{organization_id}/projects/{project_id}/apps/{name}][%d] UpdateApp default  %+v", o._statusCode, o.Payload)
}

func (o *UpdateAppDefault) String() string {
	return fmt.Sprintf("[PATCH /secrets/2023-11-28/organizations/{organization_id}/projects/{project_id}/apps/{name}][%d] UpdateApp default  %+v", o._statusCode, o.Payload)
}

func (o *UpdateAppDefault) GetPayload() *models.RPCStatus {
	return o.Payload
}

func (o *UpdateAppDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RPCStatus)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*
UpdateAppBody update app body
swagger:model UpdateAppBody
*/
type UpdateAppBody struct {

	// description
	Description string `json:"description,omitempty"`

	// sync integrations
	SyncIntegrations []string `json:"sync_integrations"`
}

// Validate validates this update app body
func (o *UpdateAppBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this update app body based on context it is used
func (o *UpdateAppBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *UpdateAppBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *UpdateAppBody) UnmarshalBinary(b []byte) error {
	var res UpdateAppBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
